//
//  MotorPositionController.h
//  MotorPositionController.h
//
//  Created by Phidgets on 2017-11-19.
//  Copyright (c) 2015 Phidgets. All rights reserved.
//

#import <Foundation/Foundation.h>
#import <Phidget22/phidget22.h>
#import "PhidgetInfoBox.h"

@interface MotorPositionController : NSObject <NSWindowDelegate>
{
    IBOutlet NSWindow *mainWindow;
    PhidgetMotorPositionControllerHandle ch;
    //PhidgetInfoBox View
    IBOutlet PhidgetInfoBox *phidgetInfoBoxView;
    IBOutlet NSBox *phidgetInfoBox;
    //Motor events
     IBOutlet NSBox *EventBox;
     IBOutlet NSTextField *motorPositionLabel;
     IBOutlet NSTextField *motorDutyCycleLabel;
    //Target position
     IBOutlet NSBox *targetPositionBox;
     IBOutlet NSStepper *targetPositionStepper;
     IBOutlet NSTextField *targetPositionText;
     IBOutlet NSTextField *incrementPositionText;
    //Configure
     IBOutlet NSBox *configureBox;
     IBOutlet NSTextField *kpText;
     IBOutlet NSStepper *kpStepper;
     IBOutlet NSTextField *kiText;
     IBOutlet NSStepper *kiStepper;
     IBOutlet NSTextField *kdText;
     IBOutlet NSStepper *kdStepper;
     IBOutlet NSTextField *accelerationText;
     IBOutlet NSStepper *accelerationStepper;
     IBOutlet NSTextField *velocityText;
     IBOutlet NSStepper *velocityStepper;
     IBOutlet NSTextField *rescaleText;
     IBOutlet NSTextField *deadbandText;
     IBOutlet NSButton *engageMotorButton;
    //Other motor settings
    NSBox *otherMotorSettingsBox;
    IBOutlet NSTextField *currentLimitText;
    IBOutlet NSStepper *currentLimitStepper;
    IBOutlet NSTextField *currentRegulatorGainText;
    IBOutlet NSStepper *currentRegulatorGainStepper;
    IBOutlet NSTextField *stallVelocityText;
    IBOutlet NSStepper *stallVelocityStepper;
    IBOutlet NSComboBox *encoderIOModeCombo;
    IBOutlet NSComboBox *fanModeCombo;
    NSBox *currentLimitBox;
    IBOutlet NSBox *currentRegulatorGainBox;
    NSBox *stallVelocityBox;
    NSBox *fanModeBox;
    NSBox *IOModeBox;
    //Errors
    IBOutlet NSPanel *errorEventLogWindow;
    IBOutlet NSTextView *errorEventLog;
    IBOutlet NSTextField *errorEventLogCounter;
    //Save settings
    IBOutlet NSPanel *settingsWindow;
    IBOutlet NSButton *saveButton;
    IBOutlet NSMatrix *settingsMatrix;
}
@end
